import birl.{type Time}
import gleam/dynamic/decode.{type Decoder}
import models/ship_symbol.{type ShipSymbol}
import models/waypoint_symbol.{type WaypointSymbol}
import utils/api

pub type ScrapTransaction {
  ScrapTransaction(
    waypoint_symbol: WaypointSymbol,
    ship_symbol: ShipSymbol,
    total_price: Int,
    timestamp: Time,
  )
}

pub fn decoder() -> Decoder(ScrapTransaction) {
  use waypoint_symbol <- decode.field(
    "waypointSymbol",
    waypoint_symbol.decoder(),
  )
  use ship_symbol <- decode.field("shipSymbol", ship_symbol.decoder())
  use total_price <- decode.field("totalPrice", decode.int)
  use timestamp <- decode.field("timestamp", api.time_decoder())
  decode.success(ScrapTransaction(
    waypoint_symbol:,
    ship_symbol:,
    total_price:,
    timestamp:,
  ))
}
