import gleam/dynamic/decode.{type Decoder}
import models/trade_symbol.{type TradeSymbol}

pub type TradeGood {
  TradeGood(symbol: TradeSymbol, name: String, description: String)
}

pub fn decoder() -> Decoder(TradeGood) {
  use symbol <- decode.field("symbol", trade_symbol.decoder())
  use name <- decode.field("name", decode.string)
  use description <- decode.field("description", decode.string)
  decode.success(TradeGood(symbol:, name:, description:))
}
